# coding: utf-8

"""
    Agilicus API

    Agilicus is API-first. Modern software is controlled by other software, is open, is available for you to use the way you want, securely, simply.  A rendered, online viewable and usable version of this specification is available at [api](https://www.agilicus.com/api). You may try the API inline directly in the web page. To do so, first obtain an Authentication Token (the simplest way is to install the Python SDK, and then run `agilicus-cli --issuer https://MYISSUER get-token`). You will need an org-id for most calls (and can obtain from `agilicus-cli --issuer https://MYISSUER list-orgs`). The `MYISSUER` will typically be `auth.MYDOMAIN`, and you will see it as you sign-in to the administrative UI.  This API releases on Bearer-Token authentication. To obtain a valid bearer token you will need to Authenticate to an Issuer with OpenID Connect (a superset of OAUTH2).  Your \"issuer\" will look like https://auth.MYDOMAIN. For example, when you signed-up, if you said \"use my own domain name\" and assigned a CNAME of cloud.example.com, then your issuer would be https://auth.cloud.example.com.  If you selected \"use an Agilicus supplied domain name\", your issuer would look like https://auth.myorg.agilicus.cloud.  For test purposes you can use our [Python SDK](https://pypi.org/project/agilicus/) and run `agilicus-cli --issuer https://auth.MYDOMAIN get-token`.  This API may be used in any language runtime that supports OpenAPI 3.0, or, you may use our [Python SDK](https://pypi.org/project/agilicus/), our [Typescript SDK](https://www.npmjs.com/package/@agilicus/angular), or our [Golang SDK](https://git.agilicus.com/pub/sdk-go).  100% of the activities in our system our API-driven, from our web-admin, through our progressive web applications, to all internals: there is nothing that is not accessible.  For more information, see [developer resources](https://www.agilicus.com/developer).   # noqa: E501

    The version of the OpenAPI document: 2021.05.14
    Contact: dev@agilicus.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from agilicus_api.configuration import Configuration


class OIDCProxyHeaderUserConfig(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'set': 'list[OIDCProxyHeaderMapping]',
        'add': 'list[OIDCProxyHeaderMapping]',
        'remove': 'list[OIDCProxyHeaderName]'
    }

    attribute_map = {
        'set': 'set',
        'add': 'add',
        'remove': 'remove'
    }

    def __init__(self, set=None, add=None, remove=None, local_vars_configuration=None):  # noqa: E501
        """OIDCProxyHeaderUserConfig - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._set = None
        self._add = None
        self._remove = None
        self.discriminator = None

        if set is not None:
            self.set = set
        if add is not None:
            self.add = add
        if remove is not None:
            self.remove = remove

    @property
    def set(self):
        """Gets the set of this OIDCProxyHeaderUserConfig.  # noqa: E501

        The list of existing headers that will be set to new values.  # noqa: E501

        :return: The set of this OIDCProxyHeaderUserConfig.  # noqa: E501
        :rtype: list[OIDCProxyHeaderMapping]
        """
        return self._set

    @set.setter
    def set(self, set):
        """Sets the set of this OIDCProxyHeaderUserConfig.

        The list of existing headers that will be set to new values.  # noqa: E501

        :param set: The set of this OIDCProxyHeaderUserConfig.  # noqa: E501
        :type: list[OIDCProxyHeaderMapping]
        """

        self._set = set

    @property
    def add(self):
        """Gets the add of this OIDCProxyHeaderUserConfig.  # noqa: E501

        The list of headers (name and value) that will be added.  # noqa: E501

        :return: The add of this OIDCProxyHeaderUserConfig.  # noqa: E501
        :rtype: list[OIDCProxyHeaderMapping]
        """
        return self._add

    @add.setter
    def add(self, add):
        """Sets the add of this OIDCProxyHeaderUserConfig.

        The list of headers (name and value) that will be added.  # noqa: E501

        :param add: The add of this OIDCProxyHeaderUserConfig.  # noqa: E501
        :type: list[OIDCProxyHeaderMapping]
        """

        self._add = add

    @property
    def remove(self):
        """Gets the remove of this OIDCProxyHeaderUserConfig.  # noqa: E501

        The list of header names that will be removed.  # noqa: E501

        :return: The remove of this OIDCProxyHeaderUserConfig.  # noqa: E501
        :rtype: list[OIDCProxyHeaderName]
        """
        return self._remove

    @remove.setter
    def remove(self, remove):
        """Sets the remove of this OIDCProxyHeaderUserConfig.

        The list of header names that will be removed.  # noqa: E501

        :param remove: The remove of this OIDCProxyHeaderUserConfig.  # noqa: E501
        :type: list[OIDCProxyHeaderName]
        """

        self._remove = remove

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OIDCProxyHeaderUserConfig):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OIDCProxyHeaderUserConfig):
            return True

        return self.to_dict() != other.to_dict()
